PRINT N'Altering Table [dbo].[AsyncInteraction]...';


GO
ALTER TABLE [dbo].[AsyncInteraction]
    ADD [Ender]  VARCHAR (300) NULL,
        [Ticket] VARCHAR (300) NULL;


GO
PRINT N'Altering Table [dbo].[Audio]...';


GO
ALTER TABLE [dbo].[Audio]
    ADD [Ender]  VARCHAR (300) NULL,
        [Ticket] VARCHAR (300) NULL;


GO
PRINT N'Altering Table [dbo].[InteractionEvaluationPlan]...';


GO
ALTER TABLE [dbo].[InteractionEvaluationPlan]
    ADD [Ender]  VARCHAR (300) NULL,
        [Ticket] VARCHAR (300) NULL;


GO
PRINT N'Altering Procedure [dbo].[BulkAsyncInteraction]...';


GO
 ALTER PROCEDURE [dbo].[BulkAsyncInteraction]
AS
BEGIN
	-- ESTE SP INSERTA REGISTROS UNICOS DE ASYNCINTERACTION PROVENIENTES DE LA BD EXTERNA EN LA TABLA ASYNCINTERACTION Y PROCESSASYNCINTERACTION

	--
	INSERT INTO [dbo].[AsyncInteraction] (
		[VCC], [ID], [Folder], [ExportedContent], [Channel]
		, [Campaign], [StartDate], [EndDate], [Account], [Initiative]
		, [ContactName], [FirstTakedAgent], [LastTakedAgent], [FirstTakedAgentName], [LastTakedAgentName]
		, [IsTaken], [TotalMessages], [DurationTime], [AttentionTime], [DispositionCode]
		, [DispositionTreePath], [RawChar], [CreatedDate], [CreatedByUserId], [TimeStamp] 
		, [ContactId], [ContactAddress], [NeedI6Update], [Ender], [Ticket] 
	)
		-- SELECCIONAMOS TODOS LOS REGISTROS DE LA TABLA TEMPORAL [#AsyncInteractionTemp] QUE NO EXISTEN EN [AsyncInteraction] POR LOS PK
		SELECT AIT.[VCC], AIT.[ID], AIT.[Folder], AIT.[ExportedContent], AIT.[Channel]
				, AIT.[Campaign], AIT.[StartDate], AIT.[EndDate], AIT.[Account], AIT.[Initiative]
				, AIT.[ContactName], AIT.[FirstTakedAgent], AIT.[LastTakedAgent], A1.[Name], A2.[Name]
				, AIT.[IsTaken], AIT.[TotalMessages], AIT.[DurationTime], AIT.[AttentionTime], AIT.[DispositionCode]
				, AIT.[DispositionTreePath], AIT.[RawChar], AIT.[CreatedDate], AIT.[CreatedByUserId], GETUTCDATE()
				, AIT.[ContactId], AIT.[contactAddress], 1, AIT.[Ender], AIT.[Ticket] 
			FROM [#AsyncInteractionTemp] AIT
			LEFT JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON AI.[VCC] = AIT.[VCC]
					AND AI.[ID] = AIT.[ID]
					AND CONVERT(VARCHAR, AI.[EndDate], 23) = AIT.[Folder]
			LEFT JOIN [dbo].[Agent] A1 (NOLOCK)
				ON A1.[VCC] = AIT.[VCC]
					AND A1.[AgentId] = AIT.[FirstTakedAgent]
			LEFT JOIN [dbo].[Agent] A2 (NOLOCK)
				ON A2.[VCC] = AIT.[VCC]
					AND A2.[AgentId] = AIT.[LastTakedAgent]
			WHERE AI.[ID] IS NULL

	--
	INSERT INTO [dbo].[ProcessAsyncInteraction] (
		[VCC], [ProcessId], [InteractionType], [Campaign], [InteractionId]
		, [EndDate], [FormattedEndDate], [CreatedDate], [CreatedByUserId], [LastModifiedDate]
		, [LastModifiedByUserId], [TimeStamp]
	)
		-- SELECCIONAMOS TODOS LOS REGISTROS DE LA TABLA TEMPORAL [#ProcessAsyncInteractionTemp] QUE NO EXISTEN EN [ProcessAsyncInteraction] POR LOS PK
		SELECT PAIT.[VCC], PAIT.[ProcessId], PAIT.[InteractionType], PAIT.[Campaign], PAIT.[InteractionId] 
				, PAIT.[EndDate], PAIT.[FormattedEndDate], PAIT.[CreatedDate], PAIT.[CreatedByUserId], PAIT.[LastModifiedDate]
				, PAIT.[LastModifiedByUserId], GETUTCDATE()
			FROM [#ProcessAsyncInteractionTemp] PAIT
			LEFT JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
				ON PAI.[VCC] = PAIT.[VCC]
					AND PAI.[ProcessId] = PAIT.[ProcessId]
					AND PAI.[InteractionType] = PAIT.[InteractionType]
					AND PAI.[InteractionId] = PAIT.[InteractionId]
					--AND PAI.[EndDate] = PAIT.[EndDate]
					AND PAI.[FormattedEndDate] = PAIT.[FormattedEndDate]
			WHERE PAI.[InteractionId] IS NULL
	
	-- ELIMINAMOS LAS TABLAS TEMPORALES
	DROP TABLE [#AsyncInteractionTemp]
	DROP TABLE [#ProcessAsyncInteractionTemp]
END
GO
PRINT N'Altering Procedure [dbo].[BulkAudio]...';


GO
ALTER PROCEDURE [dbo].[BulkAudio]
AS
BEGIN
	-- DECLARAMOS UNA VARIABLE PARA DEFINIR EL VCC
	DECLARE @VCC VARCHAR(50) = NULL
	DECLARE @VCC_TYPE VARCHAR(50) = NULL

	-- ASIGNAMOS A LA VARIABLE EL NOMBRE DEL VCC
	SELECT TOP 1 @VCC = [VCC] FROM #AudioTemp (NOLOCK)

	-- BUSCAMOS EL TIPO DE VCC
	SELECT @VCC_TYPE = V.[Type] FROM [dbo].[VCC] V (NOLOCK) WHERE V.[VCC] = @VCC

	-- ACTUALIZAR RELATIVE PATH
	UPDATE A
		SET A.[RelativePath] = ATE.[RelativePath],
			A.[RelativeFileName] = ATE.[RelativeFileName]
		FROM dbo.[AUDIO] A
		INNER JOIN #AudioTemp ATE 
			ON A.[VCC] = ATE.[VCC] 
				AND A.[ID] = ATE.[ID]
				AND A.[Section] = ATE.[Section] 
				AND A.[Part] = ATE.[Part]
		WHERE A.[IsCancel] = 1

	-- EMULAMOS UNA NUEVA TABLA EN BASE A #AudioTemp DONDE SE REMOVERAN TODOS LOS REGISTROS DUPLICADOS PARA EL PK DE LA TABLA Audio
	;WITH CTE AS (
		SELECT A.[VCC], A.[ID], A.[Section], A.[Part], A.[Number],
				A.[Gender], A.[SilenceTime], A.[DurationTime], A.[Category1], A.[Category2],
				A.[Category3], A.[Description], A.[Campaign], A.[Agent], ISNULL(A.[AgentName], AG.[Name]) 'AgentName',
				A.[Type], A.[Init], A.[StartDate], A.[EndDate], A.[DispositionCode], 
				A.[RelativePath], A.[FileName], A.[CreatedDate], A.[CreatedByUserId], A.[LastModifiedDate], 
				A.[LastModifiedByUserId], A.[ContactId], A.[ContactName], A.[ContactAddress],A.[NeedI6Update],A.[RelativeFileName], 
				A.[Ender], A.[Ticket], 
				RN = ROW_NUMBER() OVER(PARTITION BY A.[VCC], A.[ID], A.[Section], A.[Part] ORDER BY A.[ID])
			FROM #AudioTemp A (NOLOCK)
			LEFT JOIN [dbo].[Agent] AG (NOLOCK)
				ON AG.[VCC] = A.[VCC]
					AND AG.[AgentId] = A.[Agent]
	)
	-- LA TABLA TEMPORAL #AudioTemp LLEGA CON ALGUNOS REGISTROS DUPLICADOS DEBIDO A LOS CRUCES AL APLICAR LOR FILTROS, POR ELLO DEBEMOS 
	-- IDENTIFICAR LOS REPETIDOS, RN = ROW_NUMBER() OVER(PARTITION BY ...) <- NUMERA CADA REGISTRO SEGUN EL(LOS) VALOR(ES) DE ...

	-- EL CTE SOLO PUEDE SER INVOCADO UNA VEZ POR ESO LO PONEMOS EN EL SELECT FINAL DONDE EL CONTADOR(RN) ES 1
	--DELETE FROM CTE WHERE RN > 1
	

	INSERT INTO dbo.Audio(
			[VCC]
			,[ID]
			,[Section]
			,[Part]
			,[Number]
			,[Gender]
			,[SilenceTime]
			,[DurationTime]
			,[Category1]
			,[Category2]
			,[Category3]
			,[Description]
			,[Campaign]
			,[Agent]
			,[AgentName]
			,[Type]
			,[Init]
			,[NeedI6Update]
			,[StartDate]
			,[EndDate]
			,[DispositionCode]
			,[RelativePath]
			,[FileName]
			,[CreatedDate]
			,[CreatedByUserId]
			,[LastModifiedDate]
			,[LastModifiedByUserId]
			,[TimeStamp]
			,[ContactId]			
			,[ContactName]
			,[ContactAddress]
			,[RelativeFileName]
			,[Ender]
			,[Ticket]
			) 
		SELECT
			 A.[VCC]
			,A.[ID]
			,A.[Section]
			,A.[Part]
			,A.[Number]
			,A.[Gender]
			,A.[SilenceTime]
			,A.[DurationTime]
			,A.[Category1]
			,A.[Category2]
			,A.[Category3]
			,A.[Description]
			,A.[Campaign]
			,A.[Agent]
			,A.[AgentName]
			,A.[Type]
			,A.[Init]
			,A.[NeedI6Update]
			,A.[StartDate]
			,A.[EndDate]
			,A.[DispositionCode]
			,A.[RelativePath]
			,A.[FileName]
			,A.[CreatedDate]
			,A.[CreatedByUserId]
			,A.[LastModifiedDate]
			,A.[LastModifiedByUserId]
			,GETUTCDATE()
			,A.[ContactId]		
			,A.[ContactName]
			,A.[ContactAddress]
			,A.[RelativeFileName]
			,A.[Ender]
			,A.[Ticket]
		FROM CTE A (NOLOCK)
		WHERE A.RN = 1
			AND NOT EXISTS (
				SELECT * 
					FROM Audio B (NOLOCK)
					WHERE B.[VCC] = A.[VCC]
						AND B.[ID] = A.[ID]
						AND B.[Section] = A.[Section]
						AND B.[Part] = A.[Part]
			)
	




	-- EMULAMOS UNA NUEVA TABLA EN BASE A #AudioTemp DONDE SE REMOVERAN TODOS LOS REGISTROS DUPLICADOS PARA EL PK DE LA TABLA Audio
	;WITH CTE_PAT AS (
	   SELECT PAT.[VCC], PAT.[ProcessId], PAT.[AudioId], PAT.[Section], PAT.[Part]
			,PAT.[CreatedDate], PAT.[CreatedByUserId], PAT.[LastModifiedDate], PAT.[LastModifiedByUserId], RN = ROW_NUMBER() OVER(PARTITION BY PAT.[VCC], PAT.[ProcessId], PAT.[AudioId], PAT.[Section], PAT.[Part] ORDER BY PAT.[AudioId])
	   FROM #ProcessAudioTemp PAT (NOLOCK)
	)
	-- EL CTE_PAT SOLO PUEDE SER INVOCADO UNA VEZ POR ESO LO PONEMOS EN EL SELECT FINAL DONDE EL CONTADOR(RN) ES 1
	--DELETE FROM CTE_PAT WHERE RN > 1
		
	-- Insertamos registros en la tabla ProcessAudio
	INSERT INTO dbo.ProcessAudio
			([VCC]
			,[ProcessId]
			,[AudioId]
			,[Section]
			,[Part]
			,[CreatedDate]
			,[CreatedByUserId]
			,[LastModifiedDate]
			,[LastModifiedByUserId]
			,[TimeStamp]
			) 
		SELECT PAT.[VCC]
			,PAT.[ProcessId]
			,PAT.[AudioId]
			,PAT.[Section]
			,PAT.[Part]
			,PAT.[CreatedDate]
			,PAT.[CreatedByUserId]
			,PAT.[CreatedDate]
			,PAT.[CreatedByUserId]
			,GETUTCDATE()
		FROM CTE_PAT PAT (NOLOCK)
		WHERE PAT.RN = 1
			AND NOT EXISTS (
			SELECT * FROM ProcessAudio PA (NOLOCK)
			WHERE PA.[VCC] = PAT.[VCC]
			AND PA.[ProcessId] = PAT.[ProcessId]
			AND PA.[AudioId] = PAT.[AudioId]
			AND PA.[Section] = PAT.[Section]
			AND PA.[Part] = PAT.[Part]
		)
		GROUP BY 
			PAT.[VCC]
			,PAT.[ProcessId]
			,PAT.[AudioId]
			,PAT.[Section]
			,PAT.[Part]
			,PAT.[CreatedByUserId]
			,PAT.[CreatedDate]

		DROP TABLE #AudioTemp
		DROP TABLE #ProcessAudioTemp

END
GO
PRINT N'Altering Procedure [dbo].[GetEvaluationPlanInteractionByTypeAndId]...';


GO
ALTER PROCEDURE [dbo].[GetEvaluationPlanInteractionByTypeAndId] (
	@VCC VARCHAR(50) = NULL,
	@EvaluationPlanId VARCHAR(50) = NULL,
	@InteractionType VARCHAR(50) = NULL,
	@InteractionId VARCHAR(250) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- RECUPERAMOS EL PRIMER REGISTRO POR ID DE INTERACCION
	SELECT TOP 1 IEP.[Instance]											'vcc',
					IEP.[IdAgent]										'descriptionAgent',
					''													'descriptionAuditor',
					IEP.[IdCampaign]									'descriptionCampaign',
					EP.[Description]									'descriptionEvaluationPlan',
					IEP.[InteractionDateStart]							'dateIni',
					IEP.[InteractionDateEnd]							'dateFin',
					IEP.[IdInteraction]									'id',
					IEP.[IdAgent]										'idAgent',
					IEP.[AgentName]										'agentName',
					''													'idAuditorEvaluationPlan',
					IEP.[IdCampaign]									'idCampaign',
					IEP.[IdEvaluationPlan]								'idEvaluationPlan',
					IEP.[InteractionType]								'interactionType',
					IEP.[InteractionDuration]							'interactionTime',
					A.[DurationLinguisticTime]							'interactionValidTime',
					''													'origin',
					IEP.[InteractionMessages]							'totalMessages',
					ISNULL(A.[Number], IEP.[ContactId])					'number',
					IEP.[NeedI6Update]									'needI6Update',
					IEP.[Ender]										    'ender',
					IEP.[ManagementResult]								'managementResult',
					IEP.[Ticket]                                        'ticket'
					/*
					IIF (
						E.[Type] = 'i6',
						ISNULL(
							A.[NeedI6Update], 
							CAST(1 AS BIT)	
						),
						CAST(0 AS BIT)
					)													'needI6Update'
					*/

		FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		LEFT JOIN [dbo].[EvaluationPlan] EP (NOLOCK) 
			ON EP.[Instance] = IEP.[Instance]
				AND EP.[ID] = IEP.[IdEvaluationPlan]
		LEFT JOIN [dbo].[Environment] E (NOLOCK) 
			ON E.[VCC] = IEP.[Instance]
				AND E.[Name] = EP.[EnvironmentId]
		LEFT JOIN [dbo].[Audio] A (NOLOCK)
			ON A.[VCC] = IEP.[Instance]
				AND A.[ID] = IEP.[IdInteraction]
				AND A.[Section] = IEP.[InteractionSection]
				AND A.[Part] = IEP.[InteractionPart]
		WHERE IEP.[Instance] = @VCC
			AND IEP.[IdEvaluationPlan] = @EvaluationPlanId
			AND IEP.[InteractionType] = @InteractionType
			AND IEP.[IdInteraction] = @InteractionId

	SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[BulkInteractionEvaluationPlan]...';


GO
ALTER PROCEDURE [dbo].[BulkInteractionEvaluationPlan]
AS
BEGIN
	SET NOCOUNT ON

	-- DECLARAMOS UNA VARIABLE PARA DEFINIR EL VCC
	DECLARE @VCC VARCHAR(50) = NULL
	DECLARE @VCC_TYPE VARCHAR(50) = NULL
	DECLARE @NEED_I6_UPDATE BIT = 0 

	-- ASIGNAMOS A LA VARIABLE EL NOMBRE DEL VCC
	SELECT TOP 1 @VCC = [VCC] FROM [#InteractionEvaluationPlanTemp] (NOLOCK)

	-- BUSCAMOS EL TIPO DE VCC
	SELECT @VCC_TYPE = V.[Type] FROM [dbo].[VCC] V (NOLOCK) WHERE V.[VCC] = @VCC

	-- CAMBIAMOS EL VALOR DEL FLAG
	IF @VCC_TYPE = 'I6' SET @NEED_I6_UPDATE = 1

	-- INSERTAMOS LA DATA DE LA TABLA TEMPORAL
	INSERT INTO [dbo].[InteractionEvaluationPlan] (
			[Instance], [IdEvaluationPlan], [IdAgent],
			[AgentName], [IdCampaign], [IdInteraction], 
			[FormattedEndDate], [InteractionSection], [InteractionPart], 
			[InteractionDateStart], [InteractionDateEnd], [InteractionType], 
			[InteractionMessages], [InteractionDuration], [InteractionOrigin], 
			[ManagementResult], [RelativePath], [FileName],
			[ContactId], [ContactAddress], [ContactName], 
			[InteractionFormat], 
			[NeedI6Update],
			[CreatedByUserId], [CreatedDate], [TimeStamp],[RelativeFileName],
			[Ender], [Ticket])
		SELECT IEP.[VCC], IEP.[IdEvaluationPlan], IEP.[IdAgent],
				IEP.[AgentName], IEP.[IdCampaign], IEP.[IdInteraction], 
				IEP.[InteractionFolder], IEP.[InteractionSection], IEP.[InteractionPart], 
				IEP.[InteractionDateStart], IEP.[InteractionDateEnd], IEP.[InteractionType], 
				IEP.[TotalMessages], IEP.[InteractionDuration], IEP.[InteractionOrigin], 
				IEP.[InteractionManagementResult], IEP.[RelativePath], IEP.[FileName],
				IEP.[InteractionContactId], IEP.[InteractionContactAddress], IEP.[InteractionContactName],
				IEP.[InteractionFormat], 
				CASE WHEN @VCC_TYPE = 'OCC'
					THEN IIF(IEP.[InteractionType] = 'CALL', 0 , 1) 
					ELSE @NEED_I6_UPDATE
					END,
				IEP.[CreatedByUserId], GETUTCDATE(), GETUTCDATE(),[RelativeFileName],
				IEP.[Ender],
                IEP.[Ticket]
			FROM [#InteractionEvaluationPlanTemp] IEP (NOLOCK)
			/*
			LEFT JOIN [dbo].[Agent] A (NOLOCK)
				ON A.[VCC] = IEP.[VCC]
					AND A.[AgentId] = IEP.[IdAgent]
			*/

	-- ELIMINAMOS LA TABLA TEMPORAL 
	DROP TABLE [#InteractionEvaluationPlanTemp]
	
	SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[SaveI6InteractionAsyncInteractionForEvaluationPlan]...';


GO
ALTER PROCEDURE [dbo].[SaveI6InteractionAsyncInteractionForEvaluationPlan] (
	@VCC					VARCHAR(50) = NULL,
	@InteractionId			VARCHAR(250) = NULL,
	@Folder					VARCHAR(50) = NULL,
	@ExportedContent		VARCHAR(250) = NULL,
	@Channel				VARCHAR(25) = NULL,
	@StartDate				DATETIME = NULL,
	@EndDate				DATETIME = NULL,
	@DurationTime			INT = NULL,
	@AgentId				VARCHAR(50) = NULL,
	@AgentName				VARCHAR(100) = NULL,
	@Campaign				VARCHAR(100) = NULL,
	@Account				VARCHAR(50) = NULL,
	@Origin					VARCHAR(25) = NULL,
	@DispositionTreePath	VARCHAR(50) = NULL,
	@DispositionCode		VARCHAR(50) = NULL,
	@ContactId				VARCHAR(50) = NULL,
	@ContactName			VARCHAR(300) = NULL,
	@ContactAddress			VARCHAR(300) = NULL,
	@TotalMessages			INT = NULL,
	@EvaluationPlanId		VARCHAR(50) = NULL,
	@Ender					VARCHAR(300) = NULL,
	@Ticket					VARCHAR(300) = NULL
) AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR UNA INTERACCION DE I6
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- DECLARAMOS UN CURSOR PARA RECORRER PLANES
        DECLARE RECURRENT_CURSOR CURSOR 
        LOCAL STATIC READ_ONLY FORWARD_ONLY
        FOR 
        	-- SELECCIONAMOS LOS PLANES DONDE ESTA REGISTRADA LA INTERACCION
			SELECT [IdEvaluationPlan]
				FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				INNER JOIN[dbo].[EvaluationPlan] EP (NOLOCK)
					ON EP.[Instance] = IEP.[Instance]
						AND EP.[ID] = IEP.[IdEvaluationPlan]
				WHERE IEP.[Instance] = @VCC
					AND IEP.[IdInteraction] = @InteractionId
					AND IEP.[NeedI6Update] = 1
					AND (
						IEP.[IdEvaluationPlan] = @EvaluationPlanId
						OR 
						@EvaluationPlanId IS NULL
					)
					AND EP.[Status] <= 6
		
		-- DECLARARAMOS UNA VARIABLE PARA INDICAR EL CAMPO ACTUAL QUE ESTAMOS RECORRIENDO
        DECLARE @CURRENT_EVALUATION_PLAN VARCHAR(50) = ''

		-- ABRIMOS Y RECORREMOS EL ARRAY DE CAMPOS A ACTUALIZAR
        OPEN RECURRENT_CURSOR

        FETCH NEXT FROM RECURRENT_CURSOR INTO @CURRENT_EVALUATION_PLAN
        WHILE @@FETCH_STATUS = 0
        BEGIN 
			-- PARA EL PLAN ACTUAL BUSCAMOS SI EXISTE INTERACCION CON EL FOLDER CORRESPONDIENTE
			DECLARE @EXISTS_IEP BIT = 0
			SELECT @EXISTS_IEP = IIF(IEP.[IdInteraction] IS NOT NULL, CAST(1 AS BIT), CAST(0 AS BIT))
				FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK) 
				WHERE IEP.[Instance] = @VCC
					AND IEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN
					AND IEP.[IdInteraction] = @InteractionId
					AND IEP.[FormattedEndDate] = @Folder

			-- SI LA INTERACCION-FOLDER EXISTE, LA ACTUALIZAMOS
			IF @EXISTS_IEP = 1
			BEGIN
				-- ACTUALIZAMOS LA INTERACCION
				UPDATE [dbo].[InteractionEvaluationPlan] 
					SET [IdCampaign] = @Campaign,
						[IdAgent] = @AgentId,
						[AgentName] = @AgentName,
						[InteractionMessages] = @TotalMessages,
						[InteractionDateStart] = @StartDate,
						[InteractionDateEnd] = @EndDate,
						[InteractionOrigin] = IIF(@Origin = 'IN', 'E', 'S'),
						[ManagementResult] = NULL,
						[ExportedContent] = @ExportedContent,
						[ContactId] = @ContactId,
						[ContactName] = @ContactName,
						[ContactAddress] = @ContactAddress,
						[NeedI6Update] = 0,
						[LastModifiedByUserId] = 'system',
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE(),
						[Ender] = @Ender,
						[Ticket] = @Ticket
					WHERE [Instance] = @VCC
						AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN
						AND [IdInteraction] = @InteractionId
						AND [FormattedEndDate] = @Folder
						AND [NeedI6Update] = 1
			END
			-- SI LA INTERACCION-FOLDER NO EXISTE, LA INSERTAMOS
			ELSE
			BEGIN
				-- INSERTAMOS LA INTERACCION  SELECT * FROM [dbo].[InteractionEvaluationPlan]
				INSERT INTO [dbo].[InteractionEvaluationPlan] (
					[Instance], [IdEvaluationPlan], [InteractionType], [FormattedEndDate], [IdCampaign],
					[IdInteraction], [IdAgent], [AgentName], [InteractionMessages], [InteractionDateStart], 
					[InteractionDateEnd], [InteractionDuration], [InteractionOrigin], [ManagementResult], [ExportedContent],
					[ContactId], [ContactName], [ContactAddress], [NeedI6Update], [CreatedByUserId], 
					[CreatedDate], [TimeStamp], [Ender], [Ticket]
				) VALUES (
					@VCC, @CURRENT_EVALUATION_PLAN, @Channel, @Folder, @Campaign,
					@InteractionId, @AgentId, @AgentName, @TotalMessages, @StartDate, 
					@EndDate, @DurationTime, IIF(@Origin = 'IN', 'E', 'S'), @DispositionTreePath + @DispositionCode, @ExportedContent,
					@ContactId, @ContactName, @ContactAddress, CAST(0 AS BIT), 'system', 
					GETUTCDATE(), GETUTCDATE(), @Ender, @Ticket
				)
			END

			-- DECLARAMOS UN CURSOR PARA RECORRER AUDITORES
			DECLARE RECURRENT_CURSOR_02 CURSOR 
			LOCAL STATIC READ_ONLY FORWARD_ONLY
			FOR 
        		-- SELECCIONAMOS LOS AUDITORES QUE TIENEN ASIGNADA LA INTERACCION
				SELECT AEP.[IdAuditor]
					FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					WHERE AEP.[Instance] = @VCC 
						AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN
						AND AEP.[IdInteraction] = @InteractionId

			-- DECLARARAMOS UNA VARIABLE PARA INDICAR EL CAMPO ACTUAL QUE ESTAMOS RECORRIENDO
			DECLARE @CURRENT_AUDITOR VARCHAR(50) = ''

			-- ABRIMOS Y RECORREMOS EL ARRAY DE CAMPOS A ACTUALIZAR
			OPEN RECURRENT_CURSOR_02

			FETCH NEXT FROM RECURRENT_CURSOR_02 INTO @CURRENT_AUDITOR
			WHILE @@FETCH_STATUS = 0
			BEGIN 
				-- PARA EL PLAN ACTUAL BUSCAMOS SI EXISTE INTERACCION CON EL FOLDER CORRESPONDIENTE
				DECLARE @EXISTS_AEP BIT = 0
				SELECT @EXISTS_AEP = IIF(AEP.[IdInteraction] IS NOT NULL, CAST(1 AS BIT), CAST(0 AS BIT))
					FROM [dbo].[InteractionEvaluationPlan] AEP (NOLOCK) 
					WHERE AEP.[Instance] = @VCC
						AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN
						AND AEP.[IdInteraction] = @InteractionId
						AND AEP.[FormattedEndDate] = @Folder

				-- SI LA INTERACCION-FOLDER EXISTE, LA ACTUALIZAMOS
				IF @EXISTS_IEP = 1
				BEGIN
					-- ACTUALIZAMOS EL REGISTRO DE AUDITOREVALUATIONPLAN
					UPDATE [dbo].[AuditorEvaluationPlan] 
						SET [IdCampaign] = @Campaign,
							[IdAgent] = @AgentId,
							[InteractionDate] = @StartDate,
							[InteractionDateEnd] = @EndDate,
							[InteractionOrigin] = @Origin,
							[ContactId] = @ContactId,
							[ContactName] = @ContactName,
							[ContactAddress] = @ContactAddress,
							[ManagementResult] = @DispositionTreePath + @DispositionCode,
							[LastModifiedByUserId] = 'system',
							[LastModifiedDate] = GETUTCDATE(),
							[TimeStamp] = GETUTCDATE()
						WHERE [Instance] = @VCC
							AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN
							AND [IdInteraction] = @InteractionId
							AND [IdAuditor] = @CURRENT_AUDITOR
				END
				/* NO ES NECESARIO INSERTAR
				ELSE
				BEGIN
					-- INSERTAMOS EL REGISTRO A AUDITOREVALUATIONPLA
					INSERT INTO [dbo].[AuditorEvaluationPlan] (
						[Instance], [IdEvaluationPlan], [IdAuditor], [IdInteraction], [Completed], 
						[Score], [IdCampaign], [IdAgent], [InteractionDate], [InteractionType], 
						[InteractionDuration], [InteractionOrigin], [InteractionDateEnd], [ManagementResult], [ContactId], 
						[ContactName], [ContactAddress], [Status], [StatusDescription],
						[CreatedByUserId], [CreatedDate], [TimeStamp]
					) VALUES (
						@VCC, @CURRENT_EVALUATION_PLAN, @CURRENT_AUDITOR, @InteractionId, 0,
						0, @Campaign, @AgentId, @StartDate, @Channel, 
						@DurationTime, @Origin, @EndDate, @DispositionTreePath + @DispositionCode, @ContactId,
						@ContactName, @ContactAddress, 1, 'NEW',
						'system', GETUTCDATE(), GETUTCDATE()
					)
				END
				*/

				FETCH NEXT FROM RECURRENT_CURSOR_02 INTO @CURRENT_AUDITOR
			END
			CLOSE RECURRENT_CURSOR_02
			DEALLOCATE RECURRENT_CURSOR_02

		    FETCH NEXT FROM RECURRENT_CURSOR INTO @CURRENT_EVALUATION_PLAN
        END
        CLOSE RECURRENT_CURSOR
        DEALLOCATE RECURRENT_CURSOR

		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[SaveI6InteractionSyncInteractionForEvaluationPlan]...';


GO
ALTER PROCEDURE [dbo].[SaveI6InteractionSyncInteractionForEvaluationPlan] (
	@VCC					VARCHAR(50) = NULL,
	@InteractionId			VARCHAR(250) = NULL,
	@OldSection				INT = NULL,
	@OldPart				INT = NULL,
	@NewSection				INT = NULL,
	@NewPart				INT = NULL,
	@StartDate				DATETIME = NULL,
	@EndDate				DATETIME = NULL,
	@DurationTime			INT = NULL,
	@Format					VARCHAR(10) = NULL,
	@AgentId				VARCHAR(50) = NULL,
	@AgentName				VARCHAR(100) = NULL,
	@Campaign				VARCHAR(100) = NULL,
	@Origin					VARCHAR(25) = NULL,
	@Category1				VARCHAR(100) = NULL,
	@Category2				VARCHAR(100) = NULL,
	@Category3				VARCHAR(100) = NULL,
	@Description			VARCHAR(100) = NULL,
	@ContactId				VARCHAR(50) = NULL,
	@ContactName			VARCHAR(300) = NULL,
	@ContactAddress			VARCHAR(300) = NULL,
	@EvaluationPlanId		VARCHAR(50) = NULL,
	@Ender				    VARCHAR(300) = NULL,
	@Ticket					VARCHAR(300) = NULL
) AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR UNA INTERACCION DE I6
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- DECLARAMOS UN CURSOR PARA RECORRER PLANES
        DECLARE RECURRENT_CURSOR CURSOR 
        LOCAL STATIC READ_ONLY FORWARD_ONLY
        FOR 
        	-- SELECCIONAMOS LOS PLANES DONDE ESTA REGISTRADA LA INTERACCION
			SELECT DISTINCT [IdEvaluationPlan]
				FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				INNER JOIN[dbo].[EvaluationPlan] EP (NOLOCK)
					ON EP.[Instance] = IEP.[Instance]
						AND EP.[ID] = IEP.[IdEvaluationPlan]
				WHERE IEP.[Instance] = @VCC
					AND IEP.[IdInteraction] = @InteractionId
					AND IEP.[NeedI6Update] = 1
					AND (
						IEP.[IdEvaluationPlan] = @EvaluationPlanId
						OR 
						@EvaluationPlanId IS NULL
					)
					AND EP.[Status] <= 6

		-- DECLARARAMOS UNA VARIABLE PARA INDICAR EL CAMPO ACTUAL QUE ESTAMOS RECORRIENDO
        DECLARE @CURRENT_EVALUATION_PLAN VARCHAR(50) = ''

		-- ABRIMOS Y RECORREMOS EL ARRAY DE CAMPOS A ACTUALIZAR
        OPEN RECURRENT_CURSOR

        FETCH NEXT FROM RECURRENT_CURSOR INTO @CURRENT_EVALUATION_PLAN
        WHILE @@FETCH_STATUS = 0
        BEGIN 
			-- PARA EL PLAN ACTUAL BUSCAMOS SI EXISTE INTERACCION CON EL OLD-SECTION Y OLD-PART CORRESPONDIENTE
			DECLARE @EXISTS_IEP BIT = 0
			SELECT @EXISTS_IEP = IIF(IEP.[IdInteraction] IS NOT NULL, CAST(1 AS BIT), CAST(0 AS BIT))
				FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK) 
				WHERE IEP.[Instance] = @VCC
					AND IEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN
					AND IEP.[IdInteraction] = @InteractionId
					AND IEP.[InteractionSection] = @OldSection
					AND IEP.[InteractionPart] = @OldPart

			-- SI LA INTERACCION-SECTION-PART EXISTE, LA ACTUALIZAMOS
			IF @EXISTS_IEP = 1
			BEGIN
				-- ACTUALIZAMOS LA INTERACCION
				UPDATE [dbo].[InteractionEvaluationPlan] 
					SET [IdCampaign] = @Campaign,
						[InteractionSection] = @NewSection,
						[InteractionPart] = @NewPart,
						[IdAgent] = @AgentId,
						[AgentName] = @AgentName,
						[InteractionDateStart] = @StartDate,
						[InteractionDateEnd] = @EndDate,
						[InteractionOrigin] = @Origin,
						[InteractionFormat] = @Format,
						[ManagementResult] = @Category1 + @Category2 + @Category3 + @Description, 
						[ContactId] = @ContactId,
						[ContactName] = @ContactName,
						[ContactAddress] = @ContactAddress,
						[NeedI6Update] = 0,
						[LastModifiedByUserId] = 'system',
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE(),
						[Ender] = @Ender,
						[Ticket] = @Ticket
					WHERE [Instance] = @VCC
						AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN
						AND [IdInteraction] = @InteractionId
						AND [InteractionSection] = @OldSection
						AND [InteractionPart] = @OldPart
						AND [NeedI6Update] = 1
			END
			-- SI LA INTERACCION-SECTION-PART NO EXISTE, LA INSERTAMOS
			ELSE
			BEGIN
				-- INSERTAMOS LA INTERACCION  SELECT * FROM [dbo].[InteractionEvaluationPlan]
				INSERT INTO [dbo].[InteractionEvaluationPlan] (
					[Instance], [IdEvaluationPlan], [InteractionType], [IdCampaign], [IdInteraction], 
					[InteractionSection], [InteractionPart], [IdAgent], [AgentName], [InteractionDateStart], 
					[InteractionDateEnd], [InteractionDuration], [InteractionOrigin], [InteractionFormat], [ManagementResult], 
					[ContactId], [ContactName], [ContactAddress], [NeedI6Update], [CreatedByUserId], 
					[CreatedDate], [TimeStamp], [Ender], [Ticket]
				) VALUES (
					@VCC, @CURRENT_EVALUATION_PLAN, 'CALL', @Campaign, @InteractionId, 
					@NewSection, @NewPart, @AgentId, @AgentName, @StartDate, 
					@EndDate, @DurationTime, @Origin, @Format, @Category1 + @Category2 + @Category3 + @Description, 
					@ContactId, @ContactName, @ContactAddress, CAST(0 AS BIT), 'system', 
					GETUTCDATE(), GETUTCDATE(), @Ender, @Ticket
				)
			END

			-- DECLARAMOS UN CURSOR PARA RECORRER AUDITORES
			DECLARE RECURRENT_CURSOR_02 CURSOR 
			LOCAL STATIC READ_ONLY FORWARD_ONLY
			FOR 
        		-- SELECCIONAMOS LOS AUDITORES QUE TIENEN ASIGNADA LA INTERACCION
				SELECT AEP.[IdAuditor]
					FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					WHERE AEP.[Instance] = @VCC 
						AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN
						AND AEP.[IdInteraction] = @InteractionId

			-- DECLARARAMOS UNA VARIABLE PARA INDICAR EL CAMPO ACTUAL QUE ESTAMOS RECORRIENDO
			DECLARE @CURRENT_AUDITOR VARCHAR(50) = ''

			-- ABRIMOS Y RECORREMOS EL ARRAY DE CAMPOS A ACTUALIZAR
			OPEN RECURRENT_CURSOR_02

			FETCH NEXT FROM RECURRENT_CURSOR_02 INTO @CURRENT_AUDITOR
			WHILE @@FETCH_STATUS = 0
			BEGIN 
				-- PARA EL PLAN ACTUAL BUSCAMOS SI EXISTE INTERACCION CON EL FOLDER CORRESPONDIENTE
				DECLARE @EXISTS_AEP BIT = 0
				SELECT @EXISTS_AEP = IIF(AEP.[IdInteraction] IS NOT NULL, CAST(1 AS BIT), CAST(0 AS BIT))
					FROM [dbo].[InteractionEvaluationPlan] AEP (NOLOCK) 
					WHERE AEP.[Instance] = @VCC
						AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN
						AND AEP.[IdInteraction] = @InteractionId

				-- SI LA INTERACCION-FOLDER EXISTE, LA ACTUALIZAMOS
				IF @EXISTS_AEP = 1
				BEGIN
					-- ACTUALIZAMOS EL REGISTRO DE AUDITOREVALUATIONPLAN
					UPDATE [dbo].[AuditorEvaluationPlan] 
						SET [IdCampaign] = @Campaign,
							[IdAgent] = @AgentId,
							[InteractionFormat] = @Format,
							[ManagementResult] = @Category1 + @Category2 + @Category3 + @Description,
							[ContactId] = @ContactId,
							[ContactName] = @ContactName,
							[ContactAddress] = @ContactAddress,
							[LastModifiedByUserId] = 'system',
							[LastModifiedDate] = GETUTCDATE(),
							[TimeStamp] = GETUTCDATE()
						WHERE [Instance] = @VCC
							AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN
							AND [IdInteraction] = @InteractionId
							AND [IdAuditor] = @CURRENT_AUDITOR
							AND [Completed] = 0
				END
				ELSE
				BEGIN
					-- INSERTAMOS EL REGISTRO A AUDITOREVALUATIONPLA
					INSERT INTO [dbo].[AuditorEvaluationPlan] (
						[Instance], [IdEvaluationPlan], [IdAuditor], [IdInteraction], [Completed], 
						[Score], [IdCampaign], [IdAgent], [InteractionDate], [InteractionType], 
						[InteractionDuration], [InteractionOrigin], [InteractionDateEnd], [ManagementResult], [ContactId], 
						[ContactName], [ContactAddress], [Status], [StatusDescription],
						[CreatedByUserId], [CreatedDate], [TimeStamp]
					) VALUES (
						@VCC, @CURRENT_EVALUATION_PLAN, @CURRENT_AUDITOR, @InteractionId, 0,
						0, @Campaign, @AgentId, @StartDate, 'CALL', 
						@DurationTime, @Origin, @EndDate, @Category1 + @Category2 + @Category3 + @Description, @ContactId,
						@ContactName, @ContactAddress, 1, 'NEW',
						'system', GETUTCDATE(), GETUTCDATE()
					)
				END

				FETCH NEXT FROM RECURRENT_CURSOR_02 INTO @CURRENT_AUDITOR
			END
			CLOSE RECURRENT_CURSOR_02
			DEALLOCATE RECURRENT_CURSOR_02

			FETCH NEXT FROM RECURRENT_CURSOR INTO @CURRENT_EVALUATION_PLAN
        END
        CLOSE RECURRENT_CURSOR
        DEALLOCATE RECURRENT_CURSOR

		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[GetAgentsFromEvaluation]...';


GO
-- ESTE SP RETORNA LOS AGENTES ASOCIADOS A EVALUACIONES
ALTER PROCEDURE [dbo].[GetAgentsFromEvaluation] 
(
	@VCC					VARCHAR(50) = NULL,
	@UserId					VARCHAR(50) = NULL,
	@Campaigns				VARCHAR(MAX) = NULL,
	@SearchType				VARCHAR(50) = NULL,
	@EfectivityMode			BIT = 0 
) 
AS
BEGIN
	-- DECLARAMOS UN CADENA PARA EL QUERY FINAL
	DECLARE @SQL_SELECT VARCHAR(MAX) = '';
	DECLARE @SQL_FROM VARCHAR(MAX) = '';
	DECLARE @SQL_FROM_EFECTIVITY VARCHAR(MAX) = '';
	DECLARE @SQL_FILTER VARCHAR(MAX) = '';
	DECLARE @SQL_FILTER_EFECTIVITY VARCHAR(MAX) = '';
	DECLARE @SQL_EXTRA VARCHAR(MAX) = '';

	-- ARMAMOS EL QUERY PARA HACER LA CONSULTA
	SET @SQL_SELECT += '
		SELECT DISTINCT IEP.[Instance]							''vcc'', 
						IEP.[IdAgent]							''userId''
						-- IEP.[IdCampaign]						''campaignId'' -- NO SE USA APARENTEMENTE (PROBLEMA SAT V.3.7.0) '

	-- ARMAMOS LA PARTE DE TABLAS 
	SET @SQL_FROM += '
			FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) 
			INNER JOIN [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				ON IEP.[Instance] = AEP.[Instance]
					AND IEP.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
					AND IEP.[IdInteraction] = AEP.[IdInteraction] '
	SET @SQL_FROM_EFECTIVITY += '
			FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) 
			INNER JOIN [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				ON IEP.[Instance] = AEP.[Instance]
					AND IEP.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
					AND IEP.[IdInteraction] = AEP.[IdInteraction] 
			INNER JOIN (
				SELECT DISTINCT [VCC],
								[InteractionId],
								[AgentId],
								[EvaluationPlanId],
								[AuditorId] 
					FROM [dbo].[EvaluationResultEfectivity] (NOLOCK)
					WHERE [VCC] = ''' + @VCC + ' '' 
						AND [EfectivityStatus] IN (''' + 'CREATED' + '''' + ',' + '''' + 'DRAFT' + ''''+ ')' + '
			) AS ERE ON 
				(AEP.[Instance] = ERE.[VCC] 
					AND AEP.[IdEvaluationPlan] = ERE.[EvaluationPlanId]
					AND AEP.[IdInteraction] = ERE.[InteractionId])'	

	-- ARMAMOS LA PARTE DE FILTROS
	SET @SQL_FILTER += '
			WHERE AEP.[Instance] = ''' + @VCC + ''' AND IEP.[IdAgent] IS NOT NULL'
	SET @SQL_FILTER_EFECTIVITY += '
			WHERE AEP.[Instance] = ''' + @VCC + ''' AND IEP.[IdAgent] IS NOT NULL'

	-- ARMAMOS LA PARTE DE EXTRAS
	SET @SQL_EXTRA = '
			ORDER BY IEP.[IdAgent] ASC '

	-- FILTRAMOS SEGUN EL TIPO DE BUSQUEDA
	IF @SearchType = 'PENDING'
	BEGIN
		-- HACEMOS LA BUSQUEDA SOBRE LAS INTERACCIONES QUE NO HAN SIDO EVALUADAS
		SET @SQL_FILTER += '
			AND AEP.[Completed] = 0 '
	END
	ELSE IF @SearchType = 'HISTORY'
	BEGIN
		-- HACEMOS LA BUSQUEDA SOBRE LAS INTERACCIONES QUE YA HAN SIDO EVALUADAS
		SET @SQL_FILTER += '
			AND AEP.[Completed] = 1 '
	END

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR EL ROLE DEL USUARIO
	DECLARE @USER_ROLE VARCHAR(50) 
	SELECT TOP 1 @USER_ROLE = U.[Role] 
		FROM [dbo].[User] U (NOLOCK) 
		WHERE U.[VCC] = @VCC
			AND U.[ID] = @UserId

	-- FILTRAMOS SEGUN EL ROLE DEL USUARIO
	-- IF @RoleId = 'administrator, quality_admin'
	IF @USER_ROLE = 'quality_auditor'
	BEGIN
		-- HACEMOS LA BUSQUEDA SOBRE LAS INTERACCIONES AUDITADAS POR EL USUARIO
		SET @SQL_FILTER += '
			AND AEP.[IdAuditor] = ''' + @UserId + ''' '
		SET @SQL_FILTER_EFECTIVITY += '
			AND ERE.[AuditorId] = ''' + @UserId + ''' '
	END
	ELSE IF @USER_ROLE = 'quality_agent'
	BEGIN
		-- HACEMOS LA BUSQUEDA SOBRE LAS INTERACCIONES HECHAS POR EL USUARIO
		SET @SQL_FILTER += '
			AND AEP.[IdAgent] = ''' + @UserId + ''' '
	END

	-- FILTRAMOS SEGUN EL VALOR DE CAMPAIGNS
	IF @Campaigns IS NOT NULL AND @Campaigns <> ''
	BEGIN
		SET @SQL_FILTER += '
			AND AEP.[IdCampaign] IN (SELECT Value FROM [dbo].[split](''' + @Campaigns + ''','','')) '
        SET @SQL_FILTER_EFECTIVITY += '
			AND AEP.[IdCampaign] IN (SELECT Value FROM [dbo].[split](''' + @Campaigns + ''','','')) '
	END 

	-- UNIMOS LAS PARTES DEL QUERY
	IF (@EfectivityMode =1)
	SET @SQL_SELECT += @SQL_FROM_EFECTIVITY + @SQL_FILTER_EFECTIVITY + @SQL_EXTRA
	ELSE
	SET @SQL_SELECT += @SQL_FROM + @SQL_FILTER + @SQL_EXTRA
	
	-- EJECUTAMOS LA CONSULTA
	-- PRINT @SQL_SELECT
	EXEC (@SQL_SELECT)
	
END
GO
PRINT N'Altering Procedure [dbo].[GetAllegroInteractions]...';


GO
ALTER PROCEDURE [dbo].[GetAllegroInteractions] (
	@Ip						VARCHAR(50),
	@VCC					VARCHAR(50),
	@StartDate				DATETIME = NULL,
	@EndDate				DATETIME = NULL,
	@StartHour				VARCHAR(50),
	@EndHour				VARCHAR(50),
	@Campaign				VARCHAR(MAX),
	@Agent					VARCHAR(MAX),
	@ResultCode				VARCHAR(MAX),
	@Type					INT,
	@Origin					VARCHAR(MAX),
	@MinDuration			INT,
	@MaxDuration			INT,
	@Format					VARCHAR(50) = NULL, 
	@InteractionIds         VARCHAR(MAX) = NULL, 
	@Evaluated              VARCHAR(MAX) = NULL,
	-- @UniqueIds				BIT = 0,							-- ESTE FLAG TIENE COMO PROPOSITO RETORNAR LA LISTA CONSOLIDAD POR IDS O EL TOTAL DEL LISTADO (AUDIOS/INTERACTIONS)
	@ResultType				VARCHAR(50) = NULL,						-- VARIABLE PARA DETERMINAR SI LA BUSQUEDA SERA SOBRE SOBRE DETALLES O ID (DETAILED, SUMMARIZED)
	@ContactAddress			VARCHAR(300) = NULL
) AS
BEGIN
	-- SETTEAMOS UN VALOR POR DEFECTO AL FORMAT
	IF @Format IS NULL OR @Format = '' SET @Format = 'mp3,wav'

	-- SETTEAMOS VALORES MINIMOS PARA LAS HORAS DE INICIO Y FIN
	IF (@StartHour IS NOT NULL AND @StartHour = '') SET @StartHour = '00:00:00'
	IF (@EndHour IS NOT NULL AND @EndHour = '') SET @EndHour = '23:59:59'

	-- DECLARAMOS UNA VARIABLE PARA IDENTIFICAR SI EL SP ES LLAMADO DEL SISTEMA O POR OTRO SP
	DECLARE @IS_NESTED BIT = 0

	-- CREAMOS LAS VARIABLES QUE HARAN REFERENCIA A LAS TABLAS QUE PUEDEN SER EXTERNAS
	DECLARE @TABLE_HISTORICAL_DATA VARCHAR(50) = ''
	DECLARE @TABLE_MMPRODAT VARCHAR(50) = ''

	-- DECLARAMOS CADENAS PARA EL QUERY FINAL
	DECLARE @SQL_TMP VARCHAR(MAX) = ''
	DECLARE @SQL_CTE VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_SELECT VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_FROM_FIXED VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_FROM_OPTIONAL VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_FILTERS_FIXED VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_FILTERS_OPTIONAL VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_FILTERS_EXCLUDING VARCHAR(MAX) = ''
	
	DECLARE @Sql NVARCHAR(MAX)

	-- EL TYPE 0 INDICA QUE LAS TABLAS SE ENCUENTRAN EN UN SERVIDOR EXTERNO
	IF(@Type = 0)  
	BEGIN  
		SET @TABLE_HISTORICAL_DATA = '[' + @Ip + ']' + '.[HistoricalData].[dbo].'
		SET @TABLE_MMPRODAT = '[' + @Ip + ']' + '.[MMProDat].[dbo].'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @TABLE_HISTORICAL_DATA = '[HistoricalData].[dbo].'
		SET @TABLE_MMPRODAT = '[MMProDat].[dbo].'
	END
	
	IF(@Type = 0 OR @Type = 1)  
	BEGIN  
		-- VERIFICAMOS SI EXISTE LA TABLA TEMPORAL #TMP_HD_INTERACTIONS
		IF OBJECT_ID('TEMPDB..#TMP_HD_INTERACTIONS') IS NULL
		BEGIN
			-- CREAMOS UNA TABLA TEMPORAL PARA INSERTAR LOS REGISTROS DE LA HDI6
			CREATE TABLE #TMP_HD_INTERACTIONS
			(
				[ID] VARCHAR(150),
				[InteractionId] VARCHAR(100),
				[Section] INT,
				[Part] INT,
				[Channel] VARCHAR(50),
				[Number] VARCHAR(100),
				[Gender] VARCHAR(50),
				[SilenceTime] INT,
				[DurationTime] INT,
				[AttentionTime] INT,
				[Category1] VARCHAR(100),
				[Category2] VARCHAR(100),
				[Category3] VARCHAR(100),
				[Description] VARCHAR(150),
				[DispositionCode] INT,
				[Campaign] VARCHAR(150),
				[Agent] VARCHAR(100),
				[AgentName] VARCHAR(100),
				[Type] VARCHAR(100),
				[StartDate] VARCHAR(100),
				[EndDate] VARCHAR(100),
				[Format] VARCHAR(50),
				[ContactAddress] VARCHAR(300),
				[ContactId]  VARCHAR(50),
				[ContactName] VARCHAR(300),
				[RelativeFileName] VARCHAR(1000),
				[RNA] INT
			)

			-- REAFIRMAMOS QUE EL SP NO ESTA ANIDADO EN OTRO
			SET @IS_NESTED = 0
		END
		ELSE
		BEGIN
			-- SI LA TABLA TEMPORAL YA EXISTIA, EL SP ESTA ANIDADO EN OTRO (P.E.: [dbo].[GetAsyncBillingInteractions])
			SET @IS_NESTED = 1
		END 

		-- INICIAMOS ARMANDO LOS FILTROS PARA LA TABLA CTE PRINCIPAL
		SET @SQL_CTE_FILTERS_FIXED = '
				WHERE ID.[VirtualCC] = ''' + @VCC + '''
					AND ID.[EndDate] BETWEEN ''' + (SELECT CONVERT(VARCHAR(21), @StartDate, 127)) + ''' 
					AND ''' + (SELECT CONVERT(VARCHAR(21), @EndDate, 127)) + '''
					AND IMP.[Format] IN (SELECT Value FROM [dbo].[split](''' + @Format + ''','','')) '

		-- AGREGAMOS EL SCRIPT PARA LOS FILREOS DE HORA MAXIMA Y HORA MINIMA LAS CUALES TIENEN UN COMPORTAMIENTO DIFERENTES SEGUN CUAL ES MAYOR
		IF (CAST(@StartHour AS TIME) <= CAST(@EndHour AS TIME)) 
			SET @SQL_CTE_FILTERS_OPTIONAL += '
					AND CAST(ID.[EndDate] AS TIME) BETWEEN ''' + @StartHour + ''' AND ''' + @EndHour + ''' '
		IF (CAST(@StartHour AS TIME) > CAST(@EndHour AS TIME)) 
			SET @SQL_CTE_FILTERS_OPTIONAL += '
					AND CAST(ID.[EndDate] AS TIME) NOT BETWEEN ''' + @EndHour + ''' AND ''' + @StartHour + ''' '

		-- AGREGAMOS EL SCRIPT PARA EL FILTRO DE CAMPAIGN
		IF (@Campaign IS NOT NULL AND @Campaign <> '') 
		BEGIN
			-- DEBEMOS PASAR LA LISTA DE CAMPAIGNS A UNA TABLA TEMPORAL PARA AGILIZAR LA BUSQUEDA 
			SET @SQL_TMP += '
			SELECT * 
				INTO #FILTER_CAMPAIGNS
				FROM (
					SELECT Value FROM [dbo].[split](''' + @Campaign + ''','','')
				) A '

			-- AGREGAMOS EL JOIN EN LA BUSQUEDA PRINCIPAL
			SET @SQL_CTE_FROM_OPTIONAL += '  
				INNER JOIN #FILTER_CAMPAIGNS FC 
					ON FC.[Value] = ID.[Campaign] ' 
		END

		-- AGREGAMOS EL SCRIPT PARA EL FILTRO DE AGENT
		IF (@Agent IS NOT NULL AND @Agent <> '') 
		BEGIN
			-- DEBEMOS PASAR LA LISTA DE AGENTS A UNA TABLA TEMPORAL PARA AGILIZAR LA BUSQUEDA 
			SET @SQL_TMP += '
			SELECT * 
				INTO #FILTER_AGENTS
				FROM (
					SELECT Value FROM [dbo].[split](''' + @Agent + ''','','')
				) A '

			-- AGREGAMOS EL JOIN EN LA BUSQUEDA PRINCIPAL
			SET @SQL_CTE_FROM_OPTIONAL += '  
				INNER JOIN #FILTER_AGENTS FA 
					ON FA.[Value] = ISNULL(ID.[LastAgent], ID.[FirstAgent]) '
		END

		-- AGREGAMOS EL SCRPT PARA EL FILTRO ORIGEN
		IF (@Origin IS NOT NULL AND @Origin <> '') 
			SET @SQL_CTE_FILTERS_OPTIONAL += '
				AND ID.[Direction] IN (SELECT Value FROM [dbo].[split](''' + @Origin + ''','','')) '

		-- AGREGAMOS EL SCRIPT PARA LOS FILTROS DE DURACION MAXIMA Y HORA MINIMA LAS CUALES TIENEN UN COMPORTAMIENTO DIFERENTES SEGUN CUAL ES MAYOR
		IF (@MinDuration IS NOT NULL) 
			SET @SQL_CTE_FILTERS_OPTIONAL += '
				AND ID.[AttentionTime] >= ' + (SELECT CONVERT(varchar(10), @MinDuration)) + ' '
		IF (@MaxDuration IS NOT NULL) 
			SET @SQL_CTE_FILTERS_OPTIONAL += '
				AND ID.[AttentionTime] <= ' + (SELECT CONVERT(varchar(10), @MaxDuration)) + ' '

		-- AGREGAMOS EL SCRIPT PARA EL FILTRO CONTACT
		IF (@ContactAddress IS NOT NULL)
			SET @SQL_CTE_FILTERS_OPTIONAL += '
				AND ID.[ContactId] LIKE ''%' + @ContactAddress + '%'' '

		-- AGREGAMOS EL SCRIPT PARA INTERACTION_ID
		IF @InteractionIds IS NOT NULL AND @InteractionIds <> ''
		BEGIN
			SET @SQL_TMP = ''
			SET @SQL_CTE_FROM_OPTIONAL = ''
			SET @SQL_CTE_FILTERS_OPTIONAL = ''
			
			-- DEBEMOS PASAR LA LISTA DE CAMPAIGNS A UNA TABLA TEMPORAL PARA AGILIZAR LA BUSQUEDA 
			SET @SQL_TMP += '
			SELECT * 
				INTO #FILTER_INTERACTIONS_IDS
				FROM (
					SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')
				) A '
			-- AGREGAMOS EL JOIN EN LA BUSQUEDA PRINCIPAL
			SET @SQL_CTE_FROM_OPTIONAL += '  
				INNER JOIN #FILTER_INTERACTIONS_IDS FID 
					ON FID.[Value] = ID.[Id] ' 
			-- SET @SQL_CTE_FILTERS_EXCLUDING = ' AND ID.[Id] IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')) '
		END 


		-- ARMAMOS EL QUERY PARA EL CONTENIDO DE LA CTE
		SET @SQL_CTE_SELECT = '
			;WITH CTE_INTERACTION AS (
				SELECT ID.[VirtualCC]																						''VCC'',
						ID.[Id] + ''_'' + CONVERT(VARCHAR(10), IMP.[Section]) + ''_'' + CONVERT(VARCHAR(10), IMP.[Part])	''ID'',       
						ID.[Id]																								''InteractionId'',       
						IMP.[Section]																						''Section'',       
						IMP.[Part]																							''Part'',       
						''CALL''																							''Channel'',       
						CASE WHEN ID.Direction = ''E'' THEN CID.CallerId ELSE CID.CalledId END								''Number'',       
						''''																								''Gender'',      
						ID.[HoldTime]																						''SilenceTime'',       
						ID.[AttentionTime]																					''DurationTime'', -- ESTO SE DEBE CORREGIR       
						ID.[AttentionTime]																					''AttentionTime'', -- SE AGREGO CAMPO PARA AMBOS EXISTAN       
						ID.[Campaign]																						''Campaign'',       
						ISNULL(ID.[LastAgent], ID.[FirstAgent])																''Agent'',   
						ID.[ManagementResult]																				''ManagementResult'',
						ID.[Direction]																						''Type'',       
						CONVERT(VARCHAR, ID.[StartDate], 120)																''StartDate'',       
						CONVERT(VARCHAR, ID.[EndDate], 120)																	''EndDate'',       
						IMP.[Format]																						''Format'',       
						CASE WHEN ID.[Direction] = ''E'' THEN CID.[CallerId] ELSE CID.[CalledId] END						''ContactAddress'',       
						CASE WHEN ID.[Direction] = ''E'' THEN CID.[CallerId] ELSE CID.[CalledId] END						''ContactId'',       
						ID.[ContactName]																					''ContactName'',       
						IMP.[RelativePath] + ''/'' + IMP.[FileName]															''RelativeFileName'',
						CASE WHEN CID.[SourceHangup] = 0 THEN ''Client'' ELSE ''Agent'' END      							''Ender'',
						RNA = ROW_NUMBER() OVER(PARTITION BY (ID.[Id] + ''_'' + CONVERT(VARCHAR(10), IMP.[Section]) + ''_'' + CONVERT(VARCHAR(10), IMP.Part)) ORDER BY ID.[Id]) -- ROW NUMBER AUDIO            
					FROM [HistoricalData].[dbo].[InteractionDetail] ID (NOLOCK)    
					INNER JOIN [HistoricalData].[dbo].[InteractionMultimediaParts] IMP (NOLOCK)      
						ON IMP.Id = ID.Id
					INNER JOIN [HistoricalData].[dbo].[CallInteractionDetail] CID (NOLOCK)        
						ON ID.Id = CID.Id '
					+ @SQL_CTE_FROM_OPTIONAL
					+ @SQL_CTE_FILTERS_FIXED
					+ @SQL_CTE_FILTERS_OPTIONAL
					+ @SQL_CTE_FILTERS_EXCLUDING + '
			)
			,CTE_WITH_IAD AS (
				SELECT CET_I.*,
						IAD.[ActorName]											 ''agentName'' 
					FROM CTE_INTERACTION CET_I
					LEFT JOIN [HistoricalData].[dbo].[InteractionActorDetail] IAD (NOLOCK)       
						ON IAD.[VirtualCC] = CET_I.[VCC]
							AND IAD.[Id] = CET_I.[InteractionId]        
							AND IAD.[Section] = CET_I.[Section]        
							AND IAD.[Part] = CET_I.[Part]
			)
			,CTE_WITH_CGRM AS (	
				SELECT CTE_C.*,
						ISNULL(CGRM.[Category1], '''')								''Category1'',       
						ISNULL(CGRM.[Category2], '''')								''Category2'',       
						ISNULL(CGRM.[Category3], '''')								''Category3'',       
						ISNULL(CGRM.[Description], '''')							''Description'',       
						ISNULL(CONVERT(VARCHAR(4), CGRM.[Code]), '''')				''DispositionCode'' 
				FROM CTE_WITH_IAD CTE_C 
				LEFT JOIN (       
					SELECT VCC, CampaignID, [Order], [Code],            
							[Description], Category1, Category2, Category3         
						FROM [MMProDat].[dbo].[CampaignGoalResultManagement] (NOLOCK)
						WHERE VCC = ''' + @VCC + '''
				) CGRM         
					ON CGRM.VCC = CTE_C.[VCC]         
						AND CGRM.CampaignId = CTE_C.[Campaign]
						AND CGRM.[Description] = CTE_C.[ManagementResult]'

		-- AGREGAMOS EL SCRIPT PARA RESULTADO DE GESTION
		IF (@ResultCode IS NOT NULL AND @ResultCode <> '') 
		BEGIN
			-- DEBEMOS PASAR LA LISTA DE CAMPAIGNS A UNA TABLA TEMPORAL PARA AGILIZAR LA BUSQUEDA 
			SET @SQL_TMP += '
			SELECT * 
				INTO #FILTER_RESULT_CODES
				FROM (
					SELECT Value FROM [dbo].[split](''' + @ResultCode + ''','','')
				) A '

			-- AGREGAMOS EL JOIN EN LA BUSQUEDA PRINCIPAL
			SET @SQL_CTE_SELECT += '  
				INNER JOIN #FILTER_RESULT_CODES FRC 
					ON (
						FRC.[Value] = CONCAT(CTE_C.[Campaign], ''_'', ISNULL(CONVERT(VARCHAR(4), CGRM.[Code]), ''''))
						OR
						FRC.[Value] = CTE_C.[ManagementResult] 
					) '
		END

		SET @SQL_CTE_SELECT += '
			) -- SELECT * FROM CTE_WITH_CGRM'

		-- ARMAMOS EL QUERY PRINCIPAL
		SET @SQL_CTE = @SQL_TMP + @SQL_CTE_SELECT

		-- SEGUN SI EL SP ES ANIDADO O NO INSERTAMOS EN LA TEMPORAL EXISTENTE O LA CREAMOS
		IF @IS_NESTED = 1 
			SET @SQL_CTE += '
			INSERT INTO #TMP_HD_INTERACTIONS'	
		SET @SQL_CTE += '
			SELECT CTE_C.[ID],
					CTE_C.[InteractionId],
					CTE_C.[Section],
					CTE_C.[Part],
					CTE_C.[Channel],
					CTE_C.[Number],
					CTE_C.[Gender],
					CTE_C.[SilenceTime],
					CTE_C.[DurationTime],
					CTE_C.[AttentionTime],
					CTE_C.[Category1],
					CTE_C.[Category2],
					CTE_C.[Category3],
					CTE_C.[Description],
					CTE_C.[DispositionCode],
					CTE_C.[Campaign],
					CTE_C.[Agent],
					CTE_C.[AgentName],
					CTE_C.[Type],
					CTE_C.[StartDate],
					CTE_C.[EndDate],
					CTE_C.[Format],
					CTE_C.[ContactAddress],
					CTE_C.[ContactId],
					CTE_C.[ContactName],
					CTE_C.[RelativeFileName],
					CTE_C.[Ender],
					CTE_C.[RNA] '
		IF @IS_NESTED = 0 
			SET @SQL_CTE += '
				INTO #TMP_HD_INTERACTIONS '
		SET @SQL_CTE += '
				FROM CTE_WITH_CGRM CTE_C
			DROP TABLE IF EXISTS #FILTER_CAMPAIGNS 
			DROP TABLE IF EXISTS #FILTER_AGENTS
			DROP TABLE IF EXISTS #FILTER_RESULT_CODES
			DROP TABLE IF EXISTS #FILTER_INTERACTIONS_IDS '

		-- EJECUTAMOS EL SQL QUE NOS DEJA LA TEMPORAL #TMP_HD_INTERACTIONS CON REGISTROS
		--PRINT @SQL_CTE
		--EXEC (@SQL_CTE)
		--SELECT * FROM #TMP_HD_INTERACTIONS

		-- VARIABLES PARA TRABAJAR CON LA TABLA TEMPORAL AL FINAL DEL SP
		DECLARE @QUERY_SUMMARY VARCHAR(MAX) = ''
		DECLARE @QUERY_DETAIL VARCHAR(MAX) = ''
		DECLARE @QUERY VARCHAR(MAX) = ''
		DECLARE @QUERY_FILTER VARCHAR(MAX) = ''
		DECLARE @QUERY_JOIN VARCHAR(MAX) = ''
	
		-- FILTRO POR INTERACCIONES EVALUADAS O NO
		IF(@Evaluated IS NOT NULL AND @Evaluated <> '')
		BEGIN 
			DECLARE @EvaluatedTable TABLE (Val BIT)
			INSERT INTO @EvaluatedTable SELECT Value FROM [dbo].[split]( @Evaluated ,',')
			-- SOLAMENTE SI ES SI O NO
			IF((SELECT COUNT(Val) FROM @EvaluatedTable) = 1 )
			BEGIN
				IF((SELECT Val FROM @EvaluatedTable WHERE Val = 1) IS NOT NULL) -- Si  es Si
				BEGIN 
					SET @QUERY_JOIN = ' JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) ON (AEP.[IdInteraction] = HDI.[InteractionId] AND AEP.[Completed] = 1) '
				END
				ELSE  --Si es No
				BEGIN
					SET @QUERY_JOIN += ' LEFT JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) ON (AEP.[IdInteraction] = HDI.[InteractionId] AND AEP.[Completed] = 1) '
					SET @QUERY_FILTER = ' AND AEP.[IdInteraction] IS NULL '
				END
			END
		END
		-- FIN FILTRO INTERACCIONES EVALUADAS

		-- SI EL SP NO ESTA ANIDADO, HACEMOS SELECT AL RESULTADO A MOSTRAR
		IF @IS_NESTED = 0
		BEGIN
			-- EN AMBOS CASOS SE REQUIERE EL RESUMEN
			SET @QUERY_SUMMARY = @SQL_CTE + '
				SELECT HDI.[channel]										AS ''interactionType'',
						COUNT(DISTINCT (HDI.[InteractionId]))				AS ''interactions'',
						COUNT(DISTINCT (HDI.[ID]))							AS ''details'',
						SUM(HDI.[AttentionTime])							AS ''attentionTime''
					FROM #TMP_HD_INTERACTIONS HDI '
			SET @QUERY +=  @QUERY_SUMMARY + @QUERY_JOIN
			SET @QUERY += ' WHERE HDI.[RNA] = 1 ' + @QUERY_FILTER + ' GROUP BY HDI.[channel] '

			-- HACEMOS EL SELECT SEGUN EL TIPO DE BUSQUEDA SETTEADO
			--IF @ResultType = 'SUMMARIZED'
			--BEGIN
			-- END
			-- ELSE 
			IF @ResultType = 'DETAILED'
			BEGIN
				SET @QUERY_DETAIL = '
					SELECT HDI.* 
						FROM #TMP_HD_INTERACTIONS HDI ' 
				SET @QUERY += @QUERY_DETAIL + @QUERY_JOIN 
				SET @QUERY += ' WHERE HDI.[RNA] = 1 ' + @QUERY_FILTER + ' '
			END

			-- EJECUTAMOS LA CONSULTA
			PRINT @QUERY
			EXEC (@QUERY)
    
			-- ELIMINAMOS LA TABLA TEMPORARL
			DROP TABLE #TMP_HD_INTERACTIONS
		END

	END
	ELSE
	BEGIN
		SET @Sql = 'SELECT 1 AS ''result'''		
		EXEC (@Sql)
	END

	

END
GO
PRINT N'Creating Procedure [dbo].[UpdateStatusEvaluationPlan]...';


GO
CREATE PROCEDURE [dbo].[UpdateStatusEvaluationPlan]
(
	@VCC	    VARCHAR(50),
	@IdEvaluationPlan      VARCHAR(50),
	@Status   VARCHAR(50),
	@StatusDescription VARCHAR(50) = null
)
AS
BEGIN
	SET NOCOUNT ON
	
	--Actualizar los registros con el nuevo status
	
	UPDATE [dbo].[EvaluationPlan] 
	SET [status] = @Status, 
		[StatusDescription] = IsNull(@StatusDescription, StatusDescription)
	WHERE [Instance] = @VCC 
	AND [ID] = @IdEvaluationPlan
	
	SELECT 1 AS result

	SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[SaveI6InteractionAsyncInteraction]...';


GO
ALTER PROCEDURE [dbo].[SaveI6InteractionAsyncInteraction] (
	@VCC					VARCHAR(50) = NULL,
	@InteractionId			VARCHAR(250) = NULL,
	@Folder					VARCHAR(50) = NULL,
	@ExportedContent		VARCHAR(250) = NULL,
	@Channel				VARCHAR(25) = NULL,
	@StartDate				DATETIME = NULL,
	@EndDate				DATETIME = NULL,
	@DurationTime			INT = NULL,
	@AgentId				VARCHAR(50) = NULL,
	@Campaign				VARCHAR(100) = NULL,
	@Account				VARCHAR(50) = NULL,
	@Origin					VARCHAR(25) = NULL,
	@DispositionTreePath	VARCHAR(50) = NULL,
	@DispositionCode		VARCHAR(50) = NULL,
	@ContactId				VARCHAR(50) = NULL,
	@ContactName			VARCHAR(300) = NULL,
	@ContactAddress			VARCHAR(300) = NULL,
	@TotalMessages			INT = NULL,
	@ProcessId				VARCHAR(50) = NULL,
	@Ender				    VARCHAR(300) = NULL,
	@Ticket				    VARCHAR(300) = NULL
) AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR UNA INTERACCION DE I6
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY
	--select * from AsyncInteraction (nolock)
	--select * from InteractionEvaluationPlan (nolock)
		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- DECLARAMOS UNA VARIABLE PARA AYUDAR A LA ACTUALIZACION
		DECLARE @BD_AI_ID VARCHAR(250) = NULL
		DECLARE @NEED_I6_UPDATE BIT = 1
		DECLARE @AGENT_NAME VARCHAR(100) = NULL -- NOMBRE DEL AGENTE
		DECLARE @EVALUATION_PLAN_ID VARCHAR(50) = NULL -- ID DEL PLAN EN CASO EXISTA

		-- ASIGNAMOS EL VALOR ACTUALIZADO DEL FLAG
		SELECT @BD_AI_ID = AI.[Id],
				@NEED_I6_UPDATE = AI.[NeedI6Update]
			FROM [dbo].[AsyncInteraction] AI (NOLOCK)
			WHERE AI.[VCC] = @VCC
				AND AI.[ID] = @InteractionId
				AND AI.[Folder] = @Folder

		-- BUSCAMOS EL ID DEL PLAN EN CASO EXISTA
		SELECT @EVALUATION_PLAN_ID = EP.[ID]
			FROM [dbo].[EvaluationPlan] EP (NOLOCK)
			WHERE EP.[Instance] = @VCC 
				AND EP.[ProcessId] = @ProcessId
				AND EP.[Status] < 5
		
		-- ASIGNAMOS A LA VARIABLE EL NOMBRE DEL AGENTE
		SELECT @AGENT_NAME = A.[Name]
			FROM [dbo].[Agent] A (NOLOCK)
			WHERE A.[VCC] = @VCC
				AND A.[AgentId] = @AgentId

		-- ASIGNAMOS EL NAME EN CASO SEA NULL
		SET @AGENT_NAME = IIF((@AgentId IS NOT NULL AND @AgentId <> ''), @AgentId, NULL)
		
		-- EN CASO REQUIERAN ACTUALIZACION POR UNICA VEZ
		IF @NEED_I6_UPDATE = 1 AND @ProcessId IS NOT NULL
		BEGIN
			print @BD_AI_ID
			-- VERIFICAMOS IS EXISTE
			IF @BD_AI_ID IS NOT NULL
			BEGIN
				PRINT 'UPDATE'
				-- ACTUALIZAMOS LA TABLA DE LA INTERACCION EN LA TABLA ASYNC_INTERACTION
				UPDATE [dbo].[AsyncInteraction]
					SET [ExportedContent] = @ExportedContent,
						[Campaign]= @Campaign,
						[StartDate] = @StartDate,
						[EndDate] = @EndDate,
						[Account] = @Account,
						[Initiative] = @Origin,
						[LastTakedAgent] = @AgentId,
						[LastTakedAgentName] = @AGENT_NAME,
						[DurationTime] = @DurationTime,
						[DispositionTreePath] = @DispositionTreePath,
						[DispositionCode] = @DispositionCode,
						[ContactId] = @ContactId,
						[ContactName] = @ContactName,
						[ContactAddress] = @ContactAddress,
						[TotalMessages] = @TotalMessages,
						[NeedI6Update] = 0,
						[IsProcess] = NULL,
						[IsCancel] = NULL,
						[LastModifiedByUserId] = 'system',
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [VCC] = @VCC
						AND [ID] = @InteractionId
						AND [Folder] = @Folder
						AND [NeedI6Update] = 1
						AND (
							[IsTranscribed] IS NULL 
							OR
							[IsTranscribed] <> 1
						)

				-- ACTUALIZAMOS EL CAMPAIGN Y ENDDATE EN LA INTERACCION EN LA TABLA PROCESSAUDIO
				UPDATE [dbo].[ProcessAsyncInteraction]
					SET [Campaign] = @Campaign,
						[EndDate] = @EndDate,
						[LastModifiedByUserId] = 'system',
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [VCC] = @VCC
						AND [InteractionId] = @InteractionId
						AND [FormattedEndDate] = @Folder 
						AND [ProcessId] = @ProcessId
			END
			ELSE
			BEGIN
				-- SELECT * FROM AsyncInteraction (NOLOCK)
				-- SELECT * FROM ProcessAsyncInteraction (NOLOCK)
				-- INSERTAMOS EL REGISTRO EN ASYNC_INTERACTION
				INSERT INTO [dbo].[AsyncInteraction] (
					[VCC], [ID], [Folder], [ExportedContent], [Channel], 
					[Campaign], [StartDate], [EndDate], [Account], [Initiative], 
					[ContactId], [ContactName], [ContactAddress], [LastTakedAgent], [LastTakedAgentName], 
					[TotalMessages], [DurationTime], [AttentionTime], [DispositionCode], [DispositionTreePath], 
					[NeedI6Update], [LastModifiedByUserId], [LastModifiedDate], [TimeStamp]
				) VALUES (
					@VCC, @InteractionId, @Folder, @ExportedContent, @Channel, 
					@Campaign, @StartDate, @EndDate, @Account, @Origin, 
					@ContactId, @ContactName, @ContactAddress, @AgentId, @AGENT_NAME, 
					@TotalMessages, @DurationTime, @DurationTime, @DispositionCode, @DispositionTreePath, 
					0, 'system', GETUTCDATE(), GETUTCDATE()
				)

				-- INSERTAMOS EL REGISTRO EN PROCESS_ASYNC_INTERACTION
				INSERT INTO [dbo].[ProcessAsyncInteraction] (
					[VCC], [ProcessId], [InteractionType], [Campaign], [InteractionId],
					[EndDate], [FormattedEndDate], [CreatedDate], [CreatedByUserId], [TimeStamp]
				) VALUES (
					@VCC, @ProcessId, @Channel, @Campaign, @InteractionId, 
					@EndDate, @Folder, GETUTCDATE(), 'system', GETUTCDATE()
				)
			END
		END

		-- ACTUALIZAMOS LOS REGISTROS DE PLAN
		EXEC [dbo].[SaveI6InteractionAsyncInteractionForEvaluationPlan] 
			@VCC, @InteractionId, @Folder, @ExportedContent, @Channel,  
			@StartDate, @EndDate, @DurationTime, @AgentId, @AGENT_NAME, 
			@Campaign, @Account, @Origin, @DispositionTreePath, @DispositionCode, 
			@ContactId, @ContactName, @ContactAddress, @TotalMessages,
			@EVALUATION_PLAN_ID, @Ender, @Ticket

		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[SaveI6InteractionAudio]...';


GO
ALTER PROCEDURE [dbo].[SaveI6InteractionAudio] (
	@VCC					VARCHAR(50) = NULL,
	@InteractionId			VARCHAR(250) = NULL,
	@OldSection				INT = NULL,
	@OldPart				INT = NULL,
	@NewSection				INT = NULL,
	@NewPart				INT = NULL,
	@StartDate				DATETIME = NULL,
	@EndDate				DATETIME = NULL,
	@DurationTime			INT = NULL,
	@AgentId				VARCHAR(50) = NULL,
	@Format					VARCHAR(10) = NULL,
	@Campaign				VARCHAR(100) = NULL,
	@Origin					VARCHAR(25) = NULL,
	@Category1				VARCHAR(100) = NULL,
	@Category2				VARCHAR(100) = NULL,
	@Category3				VARCHAR(100) = NULL,
	@Description			VARCHAR(100) = NULL,
	@Filename				VARCHAR(200) = NULL,
	@ContactId				VARCHAR(50) = NULL,
	@ContactName			VARCHAR(300) = NULL,
	@ContactAddress			VARCHAR(300) = NULL,
	@ProcessId				VARCHAR(50) = NULL,
	@Ender				    VARCHAR(300) = NULL,
	@Ticket					VARCHAR(300) = NULL
) AS 
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR UNA INTERACCION DE I6
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- DECLARAMOS UNA VARIABLE PARA AYUDAR A LA ACTUALIZACION
		DECLARE @BD_A_ID VARCHAR(250) = NULL
		DECLARE @NEED_I6_UPDATE BIT = 1
		DECLARE @AGENT_NAME VARCHAR(100) = NULL -- NOMBRE DEL AGENTE
		DECLARE @EVALUATION_PLAN_ID VARCHAR(50) = NULL -- ID DEL PLAN EN CASO EXISTA

		-- ASIGNAMOS EL VALOR ACTUALIZADO DEL FLAG
		SELECT @BD_A_ID = A.[ID],
				@NEED_I6_UPDATE = A.[NeedI6Update]
			FROM [dbo].[Audio] A (NOLOCK)
			WHERE A.[VCC] = @VCC
				AND A.[ID] = @InteractionId
				AND A.[Section] = @OldSection
				AND A.[Part] = @OldPart

		-- BUSCAMOS EL ID DEL PLAN EN CASO EXISTA
		SELECT @EVALUATION_PLAN_ID = EP.[ID]
			FROM [dbo].[EvaluationPlan] EP (NOLOCK)
			WHERE EP.[Instance] = @VCC 
				AND EP.[ProcessId] = @ProcessId
				AND EP.[Status] = 1

		-- ASIGNAMOS A LA VARIABLE EL NOMBRE DEL AGENTE
		SELECT @AGENT_NAME = A.[Name]
			FROM [dbo].[Agent] A (NOLOCK)
			WHERE A.[VCC] = @VCC
				AND A.[AgentId] = @AgentId

		-- EN CASO REQUIERAN ACTUALIZACION POR UNICA VEZ
		IF @NEED_I6_UPDATE = 1 AND @ProcessId IS NOT NULL
		BEGIN
			-- VERIFICAMOS IS EXISTE
			IF @BD_A_ID IS NOT NULL
			BEGIN
				-- ACTUALIZAMOS EL SECTION Y PART EN LA INTERACCION EN LA TABLA AUDIO
				UPDATE [dbo].[Audio] 
					SET [Section] = @NewSection,
						[Part] = @NewPart,
						[Agent] = @AgentId,
						[AgentName] = @AGENT_NAME,
						[Format] = @Format,
						[Campaign]= @Campaign,
						[Type] = @Origin,
						[Category1] = @Category1,
						[Category2] = @Category2,
						[Category3] = @Category3,
						[Description] = @Description,
						[FileName] = @Filename,
						[ContactId] = @ContactId,
						[ContactName] = @ContactName,
						[ContactAddress] = @ContactAddress,
						[NeedI6Update] = 0,
						[IsProcess] = NULL,
						[IsCancel] = NULL,
						[LastModifiedByUserId] = 'system',
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [VCC] = @VCC
						AND [ID] = @InteractionId
						AND [Section] = @OldSection
						AND [Part] = @OldPart
						AND [NeedI6Update] = 1
						AND (
							[IsTranscribed] IS NULL 
							OR
							[IsTranscribed] <> 1
						)

				IF @@ROWCOUNT > 0
				BEGIN
					-- ACTUALIZAMOS EL SECTION Y PART EN LA INTERACCION EN LA TABLA PROCESSAUDIO
					UPDATE [dbo].[ProcessAudio]
						SET [Section] = @NewSection,
							[Part] = @NewPart
						WHERE [VCC] = @VCC
							AND [AudioId] = @InteractionId
							AND [Section] = @OldSection
							AND [Part] = @OldPart 
				END
			END
			ELSE
			BEGIN
				-- INSERTAMOS EL NUEVO AUDIO CUANDO NO RECIBIMOS SECTION Y PART
				INSERT INTO [dbo].[Audio] (
					[VCC], [Id], [Section], [Part], [Channel],
					[Number], [Format], [DurationTime], [Category1], [Category2],
					[Category3], [Description], [Filename], [Campaign], [Agent], 
					[AgentName], [Type], [StartDate], [EndDate], [ContactId], 
					[ContactName], [ContactAddress], [NeedI6Update], [CreatedByUserId], [CreatedDate], 
					[TimeStamp]
				)
				VALUES (
					@VCC, @InteractionId, @NewSection, @NewPart, 'CALL',
					@ContactAddress, @Format, @DurationTime, @Category1, @Category2,
					@Category3, @Description, @Filename, @Campaign, @AgentId, 
					@AGENT_NAME, @Origin, @StartDate, @EndDate, @ContactId, 
					@ContactName, @ContactAddress, 0, 'system', GETUTCDATE(), 
					GETUTCDATE()
				)

				INSERT INTO [dbo].[ProcessAudio] (
					[VCC], [ProcessId], [AudioId], [Section], [Part],
					[CreatedDate], [CreatedByUserId], [TimeStamp]
				)
				VALUES (
					@VCC, @ProcessId, @InteractionId, @NewSection, @NewPart,
					GETUTCDATE(), 'system', GETUTCDATE()
				)
			END 
		END

		-- ACTUALIZAMOS LOS REGISTROS DE PLAN
		EXEC [dbo].[SaveI6InteractionSyncInteractionForEvaluationPlan] 
			@VCC, @InteractionId, @OldSection, @OldPart, @NewSection,
			@NewPart, @StartDate, @EndDate, @DurationTime, @Format,
			@AgentId, @AGENT_NAME, @Campaign, @Origin, @Category1,
			@Category2, @Category3, @Description, @ContactId, @ContactName,
			@ContactAddress, @EVALUATION_PLAN_ID, @Ender, @Ticket
			
		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Update complete.';


GO