-- ARCHIVO CON LAS ACTUALIZACIONES DE DATA DE SQL PARA MIGRAR AL NUEVO BUILD DEL NOMBRE DE LA CARPETA
-- DECLARAMOS DOS VARIABLES, UNA CON LA VERSION DE LA QUE PARTIMOS Y OTRA CON LA NUEVA VERSION QUE ESTAMOS APUNTANDO
DECLARE @OLD_DATABASE_BUILD_VERSION VARCHAR(50) = '2.3.3'
DECLARE @NEW_DATABASE_BUILD_VERSION VARCHAR(50) = '2.4.0'

-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
BEGIN TRY
    -- VALIDAMOS QUE LA VERSION EXISTENTE COINCIDE CON NUESTRA NEW_DATABASE_BUILD_VERSION
    IF NOT EXISTS (
        SELECT 1 
            FROM [dbo].[Version] V 
            WHERE V.[BuildVersion] = @OLD_DATABASE_BUILD_VERSION
    )	
        -- LANZAMOS UN MENSAJE DE ERROR INDICANDO QUE LA VERSION ACTUAL NO COINCIDE CON LA OLD_DATABASE_BUILD_VERSION
        RAISERROR('DATABASE_ERROR_INCORRECT_TARGET_VERSION', 16, 16)
        
    -- INICIAMOS LA TRANSACCION
    BEGIN TRANSACTION




    -- AQUI EMPIEZA LA SECCION CON LOS INSERT/UPDATE/DELETE PARA LA NUEVA VERSION

--ACTUALIZAR DATA DE AUDIO ALLEGRO

UPDATE A
SET A.ContactId =CASE WHEN HID.Direction = 'E' THEN CID.CallerId ELSE CID.CalledId END,
A.ContactAddress=CASE WHEN HID.Direction = 'E' THEN CID.CallerId ELSE CID.CalledId END,
A.ContactName = HID.ContactName
FROM HistoricalData.dbo.interactionDetail HID
INNER JOIN HistoricalData.dbo.CallInteractionDetail CID ON HID.Id = CID.Id
INNER JOIN AUDIO A ON HID.id = A.id

--ACTUALIZAR DATA DE AUDIO I6
UPDATE A
SET A.ContactAddress = HDC.ContactAddress,
A.ContactName = HDC.ContactName
 FROM HistoricalDataI6.dbo.Detail_Call HDC
INNER JOIN AUDIO A ON HDC.id = A.id

--ACTUALIZAR DATA DE ASYNCINTERACTION

;WITH TEMP_TEXTINTERACTIONS AS (
SELECT id,ContactAddress FROM HistoricalDataI6.dbo.Detail_Facebook
UNION ALL
SELECT id,ContactAddress FROM HistoricalDataI6.dbo.Detail_Googleplay
UNION ALL
SELECT id,ContactAddress FROM HistoricalDataI6.dbo.Detail_Instagram
UNION ALL
SELECT id,ContactAddress FROM HistoricalDataI6.dbo.Detail_Twitter
UNION ALL
SELECT id,ContactAddress FROM HistoricalDataI6.dbo.Detail_Whatsapp
UNION ALL
SELECT id,ContactName FROM HistoricalDataI6.dbo.Detail_Chat
UNION ALL
SELECT id,ContactName FROM HistoricalDataI6.dbo.Detail_Webcontact
UNION ALL
SELECT id, CASE WHEN Initiative ='INBOUND' THEN MailFrom ELSE MailTo END  
FROM HistoricalDataI6.dbo.detail_mail)

UPDATE A
SET A.ContactAddress = TT.ContactAddress
 FROM TEMP_TEXTINTERACTIONS  TT INNER JOIN 
AsyncInteraction A ON TT.ID = A.id
--ACTUALIZAR DATA DE INTERACTIONEVALUATIONPLAN

UPDATE AI
SET AI.ContactAddress = CASE WHEN HID.Direction = 'E' THEN CID.CallerId ELSE CID.CalledId END
FROM HistoricalData.dbo.interactionDetail HID
INNER JOIN HistoricalData.dbo.CallInteractionDetail CID ON HID.Id = CID.Id
INNER JOIN InteractionEvaluationPlan AI ON HID.id = AI.IdInteraction

--ACTUALIZAR DATA DE AUDITOREVALUATIONPLAN
UPDATE AEP
SET AEP.ContactAddress = CASE WHEN HID.Direction = 'E' THEN CID.CallerId ELSE CID.CalledId END
FROM HistoricalData.dbo.interactionDetail HID
INNER JOIN HistoricalData.dbo.CallInteractionDetail CID ON HID.Id = CID.Id
INNER JOIN AuditorEvaluationPlan AEP ON HID.id = AEP.IdInteraction


--ACTUALIZAR INTERACTION EVALUATION PLAN, AUDITOR EVALUATION PLAN, AUDIO DE HistoricalDataI6 PARA INTERACCIONES DE TIPO I6

UPDATE IEP
SET IEP.ContactAddress = HD_SQ.ContactAddress
 from HistoricalDataI6.dbo.Detail_Call HD_SQ inner join InteractionEvaluationPlan IEP on HD_SQ.id = IEP.IdInteraction
 and HD_SQ.Vcc = IEP.Instance

UPDATE AEP
SET AEP.ContactAddress = HD_SQ.ContactAddress from HistoricalDataI6.dbo.Detail_Call HD_SQ inner join AuditorEvaluationPlan AEP on HD_SQ.id = AEP.IdInteraction
 and HD_SQ.Vcc = AEP.Instance

UPDATE A
SET A.ContactAddress = HD_SQ.ContactAddress from HistoricalDataI6.dbo.Detail_Call HD_SQ inner join Audio A on HD_SQ.id = A.ID
 and HD_SQ.Vcc = A.VCC
    

    -- AQUI TERMINA LA SECCION CON LOS INSERT/UPDATE/DELETE PARA LA NUEVA VERSION


    

    -- TERMINAMOS LA ACTUALIZACION DE DATA ACTUALIZANDO EL BUILDVERSION
    UPDATE [dbo].[Version] 
        SET [BuildVersion] = @NEW_DATABASE_BUILD_VERSION, 
            [IsRegistered] = 0,
            [TimeStamp] = GETUTCDATE() 
        WHERE [BuildVersion] = @OLD_DATABASE_BUILD_VERSION
    PRINT 'UPDATED_DATABASE_BUILD_VERSION'

    -- COMPLETAMOS LA TRANSACCION
    COMMIT TRANSACTION
END TRY
BEGIN CATCH
    IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

    DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
    DECLARE @Severity integer = ERROR_SEVERITY()
    DECLARE @State integer = ERROR_STATE()

    RAISERROR(@Message, @Severity, @State)
    --RETURN -1
END CATCH
